﻿Imports System.Xml
Imports System.IO
Imports System.Text

Public Class Form1
    Private Const BINARYENTITY As String = "Binary"
    Private Const DOCUMENTENTITY As String = "Document"
    Private entityClient As Exact.Services.Client.Entity.EntityClientEG
    Private entityData As Exact.Services.Client.Data.EntityData
    Private RetEntityData As Exact.Services.Client.Data.EntityData
    Private fileName As String
    Private BodyID As String
    Private AttachmentID As String

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Text = "Binary sample application"
        Button4.Text = "Create" : Button1.Text = "Retrieve"
        Button3.Text = "Browse" : Button2.Text = "Download"

        Label1.Text = "URL:Port" : Label12.Text = "http://<server>:8010/Services"
        Label3.Text = "Server" : Label4.Text = "Database"
        Label9.Text = "Subject" : Label10.Text = "Body"
        Label11.Text = "Attachment" : Label5.Text = "Document ID"
        Label6.Text = "HID" : Label7.Text = "File name"
        Label8.Text = "Download path"

        GroupBox1.Text = "For retrieve"
        GroupBox2.Text = "For create"
        TextBox4.Multiline = True

        TextBox10.Text = "http://change_me:8010/services"
        TextBox1.Text = "change_me"
        TextBox2.Text = "001"
    End Sub

    ''' <summary>
    ''' To create a new record by using Entity Create function
    ''' 1. Fill in Subject, Body and select a File as to attach to the document.
    ''' 2. Call the Chunk function to convert data into binary and chunk it. Chunk function will upload the binaries.
    ''' 3. Create document using entity client.
    ''' 4  Fill up the screen with the return value from entity client.
    ''' 7. Use Try-Catch statement to catch the exception during Create operations
    ''' </summary>
    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button4.Click
        Try
            Connect()
            BodyID = String.Empty
            AttachmentID = String.Empty
            ChunkService()
            FillData(entityClient.Create(GetFormData()))
        Catch fe As System.ServiceModel.FaultException(Of Exact.Services.Client.Data.EntityFault)
            ShowError(fe)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    ''' <summary>
    ''' To retrieve an existing record by using Entity Retrieve function
    ''' 1. Assigning a Document ID (key value) and IsBinaryServiceEnabled to get binaries prepared for download.  
    ''' 2. Retrieve Document ID using Entity client. 
    ''' 3. Record will be retrieved and this inclusive of the Binary ID if there are any (i.e. Body and Document)
    ''' 4. Binary ID of Body will be returned, and populate on the body text box
    ''' 5. Use Try-Catch statement to catch the exception during Retrieve operations
    ''' </summary>
    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            Connect()
            Dim data As New Exact.Services.Client.Data.EntityData
            data.EntityName = DOCUMENTENTITY
            If Not String.IsNullOrWhiteSpace(TextBox6.Text) Then Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "ID", .Value = TextBox6.Text})
            Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "IsBinaryServiceEnabled", .Value = True})

            FillData(entityClient.Retrieve(data))
            If Not String.IsNullOrWhiteSpace(BodyID) Then GetBodyData(BodyID)
        Catch fe As System.ServiceModel.FaultException(Of Exact.Services.Client.Data.EntityFault)
            ShowError(fe)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    ''' <summary>
    ''' Select a file as an attachment to attach to the document
    ''' </summary>''' 
    Private Sub Button3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button3.Click
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            If OpenFileDialog1.FileNames.Count > 0 Then
                For Each selectedFilenamePath As String In OpenFileDialog1.FileNames
                    TextBox5.Text = selectedFilenamePath
                    fileName = OpenFileDialog1.SafeFileName
                Next
            Else
                TextBox5.Text = OpenFileDialog1.FileName
            End If
        End If
    End Sub

    ''' <summary>
    ''' 1. This button will only be triggered after a Retrieve action is performed. 
    ''' 2. The download button is to retrieve the attachment file
    ''' 3. The file will be stored in C drive
    ''' </summary>
    Private Sub Button4_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Try
            If String.IsNullOrWhiteSpace(AttachmentID) Then
                MessageBox.Show("No atachment found")
            Else
                GetBinaryData(AttachmentID)
            End If

        Catch fe As System.ServiceModel.FaultException(Of Exact.Services.Client.Data.EntityFault)
            ShowError(fe)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    ''' <summary>
    ''' 1. Retrieve a body content from the Binary EntityData object
    ''' 2. Convert the content from a binary data to text format
    ''' 3. Merge the text and convert again if there are more than 1 packet of binary file
    ''' </summary>
    Private Sub GetBodyData(ByVal BinaryID As String)
        Dim Data As New Exact.Services.Client.Data.EntityData
        Dim Sequence As Integer = 0
        Dim uniEncoding As Encoding = Encoding.ASCII
        Dim BodyDetail As String = ""

        Data = PopulateERData(BinaryID, 0)
        RetEntityData = entityClient.Retrieve(Data)

        Try
            Dim chunk As Byte()
            chunk = RetEntityData.Properties("Data").Value

            While Not IsNothing(chunk)
                For i As Integer = LBound(chunk) To UBound(chunk)
                    BodyDetail = Chr(chunk(i))
                    BodyDetail = BodyDetail.Substring(0, 1)
                    TextBox4.Text = TextBox4.Text & BodyDetail
                Next

                chunk = Nothing
                Sequence = Sequence + 1

                Data = PopulateERData(BinaryID, Sequence)
                RetEntityData = entityClient.Retrieve(Data)
                chunk = RetEntityData.Properties("Data").Value
            End While
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' 1. Retrieve a document attachment from the Binary EntityData object
    ''' 2. Specify a location to store the file
    ''' 3. Get the binary data and merge it repetitively based on the number packet the attachment was chunked earlier
    ''' </summary>
    Private Sub GetBinaryData(ByVal BinaryID As String)
        Dim Data As New Exact.Services.Client.Data.EntityData
        Dim Sequence As Integer = 0

        TextBox9.Text = "C:\" & TextBox8.Text
        Data = PopulateERData(BinaryID, 0)
        RetEntityData = entityClient.Retrieve(Data)

        Dim fs As New FileStream(TextBox9.Text, FileMode.OpenOrCreate, FileAccess.Write)
        Dim writer As BinaryWriter = New BinaryWriter(fs)

        Try
            Dim chunk As Byte()
            chunk = RetEntityData.Properties("Data").Value
            While Not IsNothing(chunk)
                writer.Write(chunk, 0, chunk.Length)
                writer.Flush()
                chunk = Nothing
                Sequence = Sequence + 1

                Data = PopulateERData(BinaryID, Sequence)
                RetEntityData = entityClient.Retrieve(Data)
                chunk = RetEntityData.Properties("Data").Value
            End While
        Catch ex As Exception
        Finally
            writer.Close()
            fs.Close()
            MessageBox.Show("Download")
        End Try
    End Sub

    ''' <summary>
    ''' Helper function to assign binary details to Binary EntityData
    ''' </summary>
    Private Function PopulateERData(ByVal BinaryID As String, ByVal Sequence As Integer) As Exact.Services.Client.Data.EntityData
        Dim Data As New Exact.Services.Client.Data.EntityData()

        Data.EntityName = BINARYENTITY
        Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "MessageID", .Value = BinaryID})
        Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "Sequence", .Value = Sequence})

        Return Data
    End Function

    ''' <summary>
    ''' Helper function to assign text fields value to Document EntityData
    ''' </summary>
    Private Function GetFormData() As Exact.Services.Client.Data.EntityData
        Dim Data As New Exact.Services.Client.Data.EntityData

        Data.EntityName = DOCUMENTENTITY

        If Not String.IsNullOrWhiteSpace(TextBox6.Text) Then Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "ID", .Value = TextBox6.Text})
        If Not String.IsNullOrWhiteSpace(BodyID) Then Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "MessageIDBody", .Value = BodyID})
        If Not String.IsNullOrWhiteSpace(TextBox3.Text) Then Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "Subject", .Value = TextBox3.Text})
        If Not String.IsNullOrWhiteSpace(fileName) Then Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "FileName", .Value = fileName})
        If Not String.IsNullOrWhiteSpace(AttachmentID) Then Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "MessageIDDocument", .Value = AttachmentID})
        Data.Properties.Add(New Exact.Services.Client.Data.PropertyData With {.Name = "IsBinaryServiceEnabled", .Value = True})
        Return Data
    End Function

    ''' <summary>
    ''' Helper function to assign EntityData to Text fields
    ''' </summary>
    Private Sub FillData(ByVal Data As Exact.Services.Client.Data.EntityData)
        BodyID = Data.Properties("MessageIDBody").Value
        AttachmentID = Data.Properties("MessageIDDocument").Value

        TextBox3.Text = Data.Properties("Subject").Value
        TextBox4.Text = ""
        TextBox6.Text = Data.Properties("ID").Value
        TextBox7.Text = Data.Properties("HID").Value
        TextBox8.Text = Data.Properties("FileName").Value
    End Sub

    ''' <summary>
    ''' To capture the error which return by entity services
    ''' </summary>
    Private Sub ShowError(ByVal fe As System.ServiceModel.FaultException(Of Exact.Services.Client.Data.EntityFault))
        Dim sb As New System.Text.StringBuilder
        sb.AppendLine("An error has occured!")
        sb.AppendFormat("{0}: {1}" & vbCrLf, "Exception Type", fe.Reason.ToString)
        sb.AppendFormat("{0}: {1}" & vbCrLf, "Exception Message", fe.Message)
        sb.AppendLine("")

        If fe.Detail.Exceptions.Count > 0 Then
            For Each info As Exact.Services.Client.Data.WSExceptionInfo In fe.Detail.Exceptions
                With sb
                    .AppendFormat("{0}: {1}" & vbCrLf, "Property", info.PropertyName)
                    .AppendFormat("{0}: {1}" & vbCrLf, "Message", info.Message)
                    .AppendLine("")
                End With
            Next
        End If
        MessageBox.Show(sb.ToString(), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub

    Private Sub Connect()
        entityClient = New Exact.Services.Client.Entity.EntityClientEG(TextBox10.Text, TextBox1.Text, TextBox2.Text)
    End Sub

    ''' <summary>
    ''' Helper function to trigger the chunking function
    ''' </summary>
    Private Sub ChunkService()
        Dim Data As New Exact.Services.Client.Data.EntityData
        Dim FilePathCollector As New Collection

        Data.EntityName = BINARYENTITY

        If TextBox4.Text <> "" Then
            FilePathCollector.Add(TextBox4.Text, "Body")
            ChunkImage(Data, FilePathCollector)
            FilePathCollector.Clear()
        End If

        If TextBox5.Text <> "" Then
            FilePathCollector.Add(TextBox5.Text, "Document")
            ChunkImage(Data, FilePathCollector)
            FilePathCollector.Clear()
        End If

    End Sub

    ''' <summary>
    ''' To chunk data into smaller size.
    ''' 1. Read the body content and the attachment file
    ''' 2. Calculate the total size of the data and chunk it into smaller size. The default size is set to 50kb.
    ''' 3. For every chunk, the data will be passed to the Binary EntityData object.
    ''' 4. A unique ID or Message ID will be returned when the binary is saved successfully.
    ''' 5. The total number of chunk will be keep tracked in the metadata called Sequence.
    ''' 6. and the details will be stored in the metadata called Data.
    ''' </summary>
    Private Function ChunkImage(ByVal entityName As Exact.Services.Client.Data.EntityData, ByVal FilePath As Collection) As Boolean
        Dim Data As New Exact.Services.Client.Data.PropertyData
        Dim i As Integer = 0
        Dim fileLength As Integer

        Dim sTempFileName As String = Path.GetTempFileName()
        Dim fsTemp As New FileStream(sTempFileName, FileMode.Create)
        Dim uniEncoding As Encoding = Encoding.UTF8

        If FilePath.Count > 0 Then
            Cursor = Cursors.WaitCursor
            Dim fileInfo As FileInfo
            Dim chunkSize As Integer = 50 * 1024 '50KB

            Try
                Dim countLog As Integer = 0
                For Each selectedFilenamePath As String In FilePath
                    If FilePath.Contains("Body") Then
                        fsTemp.Write(uniEncoding.GetBytes(selectedFilenamePath), 0, uniEncoding.GetByteCount(selectedFilenamePath))
                        fsTemp.Close()
                        selectedFilenamePath = sTempFileName
                    End If

                    fileInfo = New FileInfo(selectedFilenamePath)
                    Dim fileSizeInBytes As Long = fileInfo.Length
                    Dim MsgID As String = "00000000-0000-0000-0000-000000000000"
                    Using iStream As New FileStream(selectedFilenamePath, FileMode.Open, FileAccess.Read, FileShare.Read)
                        Dim lastPacketDataSize As Long = fileSizeInBytes Mod chunkSize
                        Dim totalChunkPackets As Integer = Int((fileSizeInBytes / chunkSize)) + IIf(lastPacketDataSize > 0, 1, 0)
                        Dim completePacketData() As Byte = Nothing
                        completePacketData = New Byte(chunkSize - 1) {}

                        Dim countPacket As Integer = 0
                        Dim chunkSequenceNumber As Integer
                        Dim chunkPacketToWrite() As Byte
                        Dim dataToRead As Long = iStream.Length

                        While dataToRead > 0
                            If countPacket = totalChunkPackets - 1 Then
                                Dim lastPacketData() As Byte = Nothing
                                lastPacketData = New Byte(lastPacketDataSize - 1) {}
                                fileLength = iStream.Read(lastPacketData, 0, lastPacketDataSize)
                                chunkPacketToWrite = lastPacketData
                            Else
                                fileLength = iStream.Read(completePacketData, 0, chunkSize)
                                chunkPacketToWrite = completePacketData
                            End If

                            entityName.Properties.Add(New Exact.Services.Client.Data.PropertyData() With {.Name = "MessageID", .Value = MsgID})
                            entityName.Properties.Add(New Exact.Services.Client.Data.PropertyData() With {.Name = "Sequence", .Value = countPacket})
                            Dim bImg As Byte()
                            bImg = chunkPacketToWrite
                            entityName.Properties.Add(New Exact.Services.Client.Data.PropertyData() With {.Name = "Data", .Value = bImg})

                            RetEntityData = entityClient.Create(entityName)
                            MsgID = RetEntityData.Properties("MessageID").Value

                            'Reset collection
                            entityName.Properties.Clear()

                            If Not String.IsNullOrEmpty(chunkSequenceNumber) Then
                                dataToRead = dataToRead - fileLength
                                'Count total packet
                                countPacket += 1
                            Else
                                'Count total packet
                                countPacket -= 1
                            End If

                            Application.DoEvents()
                        End While
                        iStream.Close()
                    End Using
                    If FilePath.Contains("Body") Then BodyID = MsgID
                    If FilePath.Contains("Document") Then AttachmentID = MsgID

                    Application.DoEvents()
                Next

                If FilePath.Contains("Body") Then File.Delete(sTempFileName)
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            Finally
                Cursor = Cursors.Default
            End Try
            Cursor = Cursors.Default
            Return True
        Else
            Return False
        End If
    End Function
End Class
